Tools
Eina

Eina tools aims to help application development, providing ways to make it safer, log errors, manage memory more efficiently and more. More...

## Topics

| Benchmark
| These functions allow you to add a benchmark framework to a project for timing critical parts and detecting slow parts of code.
| Bezier Curve
| Convert
| These functions allow you to convert integer or real numbers to string or conversely.
| Counter
| This group discusses the functions that allow you to get the time spent in a part of a code.
| Copy On Write
| These functions provide some helper for a pseudo Copy-On-Write mechanism.
| Cpu
| Cpu and architecture related helpers
| Error
| This group discusses the functions that provide error management for projects.
| File
| This group discusses the functions to handle files and directories.
| Lazy allocator
| Lock
| This group provides thread locking and synchronization capabilities.
| Log
| Magic
| Eina_Magic provides run-time type-checking.
| Memory Pool
| This group discusses the functions that provide memory pool management.
| Module
| These functions provide module management.
| Prefix
| This group discusses the functions that provide the ability to determine the runtime location of a software package.
| Rectangle
| These functions provide rectangle management.
| Safety Checks
| Safety checks are a set of macros to check for parameters or values that should never happen, it is similar in concept to assert(), but will log and return instead of abort() your program.
| Simple_XML
| Simplistic relaxed SAX-like XML parser.
| String
| Thread
| Abstracts platform threads, providing a uniform API.
| Xattrs
| Extended Attributes handling

## Macros

#define | EINA_FLT_EQ(a, b)
| Safe comparison of float.
#define | EINA_FLT_NONZERO(a)
| Determines if a float is not zero.
#define | EINA_DBL_EQ(a, b)
| Safe comparison of double.
#define | EINA_DBL_NONZERO(a)
| Determines if a double is not zero.

## Functions

EINA_API const char * | eina_environment_home_get (void)
| Returns the content of the environment referred by HOME on this system.
EINA_API const char * | eina_environment_tmp_get (void)
| Returns the content of the environment referred as TMPDIR on this system.
static Eina_Bool | eina_dbl_exact (double a, double b)
| Warningless comparison of doubles using ==.
static Eina_Bool | eina_flt_exact (float a, float b)
| Warningless comparison of floats using ==.

## Detailed Description

Eina tools aims to help application development, providing ways to make it safer, log errors, manage memory more efficiently and more.

For more information refer to the string example.

## Macro Definition Documentation

## EINA_FLT_EQ

#define EINA_FLT_EQ | ( |  | a,
|  |  | b )

Value:
(!!(fabsf((float)(a) - (float)(b)) <= FLT_EPSILON))

Safe comparison of float.

Parameters

  [in] | a | First member to compare
  [in] | b | Second member to compare

Since
  1.19

Returns
  `true` if two floats match

## EINA_FLT_NONZERO

#define EINA_FLT_NONZERO | ( |  | a | ) |

Value:
(!!(fpclassify((float)(a)) != FP_ZERO))

Determines if a float is not zero.

Parameters

  [in] | a | The float

Returns
  `true` if float is not zero

Since
  1.19

## EINA_DBL_EQ

#define EINA_DBL_EQ | ( |  | a,
|  |  | b )

Value:
(!!(fabs((double)(a) - (double)(b)) <= DBL_EPSILON))

Safe comparison of double.

Parameters

  [in] | a | First member to compare
  [in] | b | Second member to compare

Since
  1.19

Returns
  `true` if two double match

Examples
  bg_example_03.c, client.c, edje-basic.c, evas-box.c, progressbar_example.c, and transit_example_03.c.

Referenced by ecore_animator_frametime_set(), ecore_fb_input_device_threshold_click_set(), ecore_thread_global_data_wait(), edje_password_show_last_timeout_set(), eina_bezier_on_interval(), eina_bezier_t_at(), eina_matrix2_inverse(), eina_matrix2_type_get(), eina_matrix3_equal(), eina_matrix3_inverse(), eina_matrix3_point_transform(), eina_matrix3_quad_square_map(), eina_matrix3_square_quad_map(), eina_matrix3_type_get(), eina_matrix4_quaternion_to(), eina_matrix4_type_get(), eina_quaternion_homogeneous_regulate(), eina_quaternion_lerp(), eina_quaternion_matrix4_to(), eina_quaternion_nlerp(), eina_quaternion_slerp(), elm_config_password_show_last_timeout_set(), elm_config_scale_set(), elm_config_transition_duration_factor_set(), elm_progressbar_part_value_set(), elm_slider_min_max_set(), elm_slider_step_set(), elm_slider_value_set(), elm_spinner_special_value_del(), elm_spinner_special_value_get(), elm_textpath_circle_set(), elm_transit_paused_get(), elm_transit_paused_set(), and evas_object_textblock_valign_set().

## EINA_DBL_NONZERO

#define EINA_DBL_NONZERO | ( |  | a | ) |

Value:
(!!(fpclassify((double)(a)) != FP_ZERO))

Determines if a double is not zero.

Parameters

  [in] | a | The double

Returns
  `true` if double is not zero

Since
  1.19

## Function Documentation

## eina_environment_home_get()

EINA_API const char * eina_environment_home_get | ( | void |  | ) |

Returns the content of the environment referred by HOME on this system.

Returns
  A temporary string to the content referred by HOME on this system.

Note
  The result of this call is highly system dependent and you better use it instead of the naive getenv("HOME").

Since
  1.15

Referenced by ecore_file_app_exe_get(), elm_theme_list_item_path_get(), elm_theme_name_available_list_new(), elm_theme_user_dir_get(), and ethumb_init().

## eina_environment_tmp_get()

EINA_API const char * eina_environment_tmp_get | ( | void |  | ) |

Returns the content of the environment referred as TMPDIR on this system.

Returns
  A temporary string to the content referred by TMPDIR on this system.

Note
  The result of this call is highly system dependent and you better use it instead of the naive getenv("TMPDIR").

Since
  1.15

Referenced by ecore_con_local_path_new(), eina_file_mkdtemp(), and eina_file_mkstemp().

## eina_dbl_exact()

Eina_Bool eina_dbl_exact | ( | double | a,
|  | double | b )

inline static

Warningless comparison of doubles using ==.

Parameters

  [in] | a | First member to compare
  [in] | b | Second member to compare

Returns
  `true` if two doubles match

Since
  1.19

## eina_flt_exact()

Eina_Bool eina_flt_exact | ( | float | a,
|  | float | b )

inline static

Warningless comparison of floats using ==.

Parameters

  [in] | a | First member to compare
  [in] | b | Second member to compare

Returns
  `true` if two floats match

Since
  1.19